123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763 |
- #!/bin/bash
- red='\033[0;31m'
- green='\033[0;32m'
- yellow='\033[0;33m'
- plain='\033[0m'
- #Add some basic function here
- function LOGD() {
- echo -e "${yellow}[DEG] $* ${plain}"
- }
- function LOGE() {
- echo -e "${red}[ERR] $* ${plain}"
- }
- function LOGI() {
- echo -e "${green}[INF] $* ${plain}"
- }
- # check root
- [[ $EUID -ne 0 ]] && LOGE "ERROR: You must be root to run this script! \n" && exit 1
- # check os
- if [[ -f /etc/redhat-release ]]; then
- release="centos"
- elif cat /etc/issue | grep -Eqi "debian"; then
- release="debian"
- elif cat /etc/issue | grep -Eqi "ubuntu"; then
- release="ubuntu"
- elif cat /etc/issue | grep -Eqi "centos|red hat|redhat"; then
- release="centos"
- elif cat /proc/version | grep -Eqi "debian"; then
- release="debian"
- elif cat /proc/version | grep -Eqi "ubuntu"; then
- release="ubuntu"
- elif cat /proc/version | grep -Eqi "centos|red hat|redhat"; then
- release="centos"
- else
- LOGE "check system OS failed,please contact with author! \n" && exit 1
- fi
- os_version=""
- # os version
- if [[ -f /etc/os-release ]]; then
- os_version=$(awk -F'[= ."]' '/VERSION_ID/{print $3}' /etc/os-release)
- fi
- if [[ -z "$os_version" && -f /etc/lsb-release ]]; then
- os_version=$(awk -F'[= ."]+' '/DISTRIB_RELEASE/{print $2}' /etc/lsb-release)
- fi
- if [[ x"${release}" == x"centos" ]]; then
- if [[ ${os_version} -le 6 ]]; then
- LOGE "please use CentOS 7 or higher version! \n" && exit 1
- fi
- elif [[ x"${release}" == x"ubuntu" ]]; then
- if [[ ${os_version} -lt 16 ]]; then
- LOGE "please use Ubuntu 16 or higher version!\n" && exit 1
- fi
- elif [[ x"${release}" == x"debian" ]]; then
- if [[ ${os_version} -lt 8 ]]; then
- LOGE "please use Debian 8 or higher version!\n" && exit 1
- fi
- fi
- confirm() {
- if [[ $# > 1 ]]; then
- echo && read -p "$1 [Default$2]: " temp
- if [[ x"${temp}" == x"" ]]; then
- temp=$2
- fi
- else
- read -p "$1 [y/n]: " temp
- fi
- if [[ x"${temp}" == x"y" || x"${temp}" == x"Y" ]]; then
- return 0
- else
- return 1
- fi
- }
- confirm_restart() {
- confirm "Restart the panel, Attention: Restarting the panel will also restart xray" "y"
- if [[ $? == 0 ]]; then
- restart
- else
- show_menu
- fi
- }
- before_show_menu() {
- echo && echo -n -e "${yellow}Press enter to return to the main menu: ${plain}" && read temp
- show_menu
- }
- install() {
- bash <(curl -Ls https://raw.githubusercontent.com/mhsanaei/3x-ui/main/install.sh)
- if [[ $? == 0 ]]; then
- if [[ $# == 0 ]]; then
- start
- else
- start 0
- fi
- fi
- }
- update() {
- confirm "This function will forcefully reinstall the latest version, and the data will not be lost. Do you want to continue?" "n"
- if [[ $? != 0 ]]; then
- LOGE "Cancelled"
- if [[ $# == 0 ]]; then
- before_show_menu
- fi
- return 0
- fi
- bash <(curl -Ls https://raw.githubusercontent.com/mhsanaei/3x-ui/main/install.sh)
- if [[ $? == 0 ]]; then
- LOGI "Update is complete, Panel has automatically restarted "
- exit 0
- fi
- }
- uninstall() {
- confirm "Are you sure you want to uninstall the panel? xray will also uninstalled!" "n"
- if [[ $? != 0 ]]; then
- if [[ $# == 0 ]]; then
- show_menu
- fi
- return 0
- fi
- systemctl stop x-ui
- systemctl disable x-ui
- rm /etc/systemd/system/x-ui.service -f
- systemctl daemon-reload
- systemctl reset-failed
- rm /etc/x-ui/ -rf
- rm /usr/local/x-ui/ -rf
- echo ""
- echo -e "Uninstalled Successfully,If you want to remove this script,then after exiting the script run ${green}rm /usr/bin/x-ui -f${plain} to delete it."
- echo ""
- if [[ $# == 0 ]]; then
- before_show_menu
- fi
- }
- reset_user() {
- confirm "Reset your username and password to admin?" "n"
- if [[ $? != 0 ]]; then
- if [[ $# == 0 ]]; then
- show_menu
- fi
- return 0
- fi
- /usr/local/x-ui/x-ui setting -username admin -password admin
- echo -e "Username and password have been reset to ${green}admin${plain},Please restart the panel now."
- confirm_restart
- }
- reset_config() {
- confirm "Are you sure you want to reset all panel settings,Account data will not be lost,Username and password will not change" "n"
- if [[ $? != 0 ]]; then
- if [[ $# == 0 ]]; then
- show_menu
- fi
- return 0
- fi
- /usr/local/x-ui/x-ui setting -reset
- echo -e "All panel settings have been reset to default,Please restart the panel now,and use the default ${green}2053${plain} Port to Access the web Panel"
- confirm_restart
- }
- check_config() {
- info=$(/usr/local/x-ui/x-ui setting -show true)
- if [[ $? != 0 ]]; then
- LOGE "get current settings error,please check logs"
- show_menu
- fi
- LOGI "${info}"
- }
- set_port() {
- echo && echo -n -e "Enter port number[1-65535]: " && read port
- if [[ -z "${port}" ]]; then
- LOGD "Cancelled"
- before_show_menu
- else
- /usr/local/x-ui/x-ui setting -port ${port}
- echo -e "The port is set,Please restart the panel now,and use the new port ${green}${port}${plain} to access web panel"
- confirm_restart
- fi
- }
- start() {
- check_status
- if [[ $? == 0 ]]; then
- echo ""
- LOGI "Panel is running,No need to start again,If you need to restart, please select restart"
- else
- systemctl start x-ui
- sleep 2
- check_status
- if [[ $? == 0 ]]; then
- LOGI "x-ui Started Successfully"
- else
- LOGE "panel Failed to start,Probably because it takes longer than two seconds to start,Please check the log information later"
- fi
- fi
- if [[ $# == 0 ]]; then
- before_show_menu
- fi
- }
- stop() {
- check_status
- if [[ $? == 1 ]]; then
- echo ""
- LOGI "Panel stopped,No need to stop again!"
- else
- systemctl stop x-ui
- sleep 2
- check_status
- if [[ $? == 1 ]]; then
- LOGI "x-ui and xray stopped successfully"
- else
- LOGE "Panel stop failed,Probably because the stop time exceeds two seconds,Please check the log information later"
- fi
- fi
- if [[ $# == 0 ]]; then
- before_show_menu
- fi
- }
- restart() {
- systemctl restart x-ui
- sleep 2
- check_status
- if [[ $? == 0 ]]; then
- LOGI "x-ui and xray Restarted successfully"
- else
- LOGE "Panel restart failed,Probably because it takes longer than two seconds to start,Please check the log information later"
- fi
- if [[ $# == 0 ]]; then
- before_show_menu
- fi
- }
- status() {
- systemctl status x-ui -l
- if [[ $# == 0 ]]; then
- before_show_menu
- fi
- }
- enable() {
- systemctl enable x-ui
- if [[ $? == 0 ]]; then
- LOGI "x-ui Set to boot automatically on startup successfully"
- else
- LOGE "x-ui Failed to set Autostart"
- fi
- if [[ $# == 0 ]]; then
- before_show_menu
- fi
- }
- disable() {
- systemctl disable x-ui
- if [[ $? == 0 ]]; then
- LOGI "x-ui Autostart Cancelled successfully"
- else
- LOGE "x-ui Failed to cancel autostart"
- fi
- if [[ $# == 0 ]]; then
- before_show_menu
- fi
- }
- show_log() {
- journalctl -u x-ui.service -e --no-pager -f
- if [[ $# == 0 ]]; then
- before_show_menu
- fi
- }
- migrate_v2_ui() {
- /usr/local/x-ui/x-ui v2-ui
- before_show_menu
- }
- install_bbr() {
- # temporary workaround for installing bbr
- bash <(curl -L -s https://raw.githubusercontent.com/teddysun/across/master/bbr.sh)
- echo ""
- before_show_menu
- }
- update_shell() {
- wget -O /usr/bin/x-ui -N --no-check-certificate https://github.com/mhsanaei/3x-ui/raw/main/x-ui.sh
- if [[ $? != 0 ]]; then
- echo ""
- LOGE "Failed to download script,Please check whether the machine can connect Github"
- before_show_menu
- else
- chmod +x /usr/bin/x-ui
- LOGI "Upgrade script succeeded,Please rerun the script" && exit 0
- fi
- }
- # 0: running, 1: not running, 2: not installed
- check_status() {
- if [[ ! -f /etc/systemd/system/x-ui.service ]]; then
- return 2
- fi
- temp=$(systemctl status x-ui | grep Active | awk '{print $3}' | cut -d "(" -f2 | cut -d ")" -f1)
- if [[ x"${temp}" == x"running" ]]; then
- return 0
- else
- return 1
- fi
- }
- check_enabled() {
- temp=$(systemctl is-enabled x-ui)
- if [[ x"${temp}" == x"enabled" ]]; then
- return 0
- else
- return 1
- fi
- }
- check_uninstall() {
- check_status
- if [[ $? != 2 ]]; then
- echo ""
- LOGE "Panel installed,Please do not reinstall"
- if [[ $# == 0 ]]; then
- before_show_menu
- fi
- return 1
- else
- return 0
- fi
- }
- check_install() {
- check_status
- if [[ $? == 2 ]]; then
- echo ""
- LOGE "Please install the panel first"
- if [[ $# == 0 ]]; then
- before_show_menu
- fi
- return 1
- else
- return 0
- fi
- }
- show_status() {
- check_status
- case $? in
- 0)
- echo -e "Panel state: ${green}Running${plain}"
- show_enable_status
- ;;
- 1)
- echo -e "Panel state: ${yellow}Not Running${plain}"
- show_enable_status
- ;;
- 2)
- echo -e "Panel state: ${red}Not Installed${plain}"
- ;;
- esac
- show_xray_status
- }
- show_enable_status() {
- check_enabled
- if [[ $? == 0 ]]; then
- echo -e "Start automatically: ${green}Yes${plain}"
- else
- echo -e "Start automatically: ${red}No${plain}"
- fi
- }
- check_xray_status() {
- count=$(ps -ef | grep "xray-linux" | grep -v "grep" | wc -l)
- if [[ count -ne 0 ]]; then
- return 0
- else
- return 1
- fi
- }
- show_xray_status() {
- check_xray_status
- if [[ $? == 0 ]]; then
- echo -e "xray state: ${green}Running${plain}"
- else
- echo -e "xray state: ${red}Not Running${plain}"
- fi
- }
- #this will be an entrance for ssl cert issue
- #here we can provide two different methods to issue cert
- #first.standalone mode second.DNS API mode
- ssl_cert_issue() {
- local method=""
- echo -E ""
- LOGD "********Usage********"
- LOGI "this shell script will use acme to help issue certs."
- LOGI "here we provide two methods for issuing certs:"
- LOGI "method 1:acme standalone mode,need to keep port:80 open"
- LOGI "method 2:acme DNS API mode,need provide Cloudflare Global API Key"
- LOGI "recommend method 2 first,if it fails,you can try method 1."
- LOGI "certs will be installed in /root/cert directory"
- read -p "please choose which method do you want,type 1 or 2": method
- LOGI "you choosed method:${method}"
- if [ "${method}" == "1" ]; then
- ssl_cert_issue_standalone
- elif [ "${method}" == "2" ]; then
- ssl_cert_issue_by_cloudflare
- else
- LOGE "invalid input,please check it..."
- exit 1
- fi
- }
- install_acme() {
- cd ~
- LOGI "install acme..."
- curl https://get.acme.sh | sh
- if [ $? -ne 0 ]; then
- LOGE "install acme failed"
- return 1
- else
- LOGI "install acme succeed"
- fi
- return 0
- }
- #method for standalone mode
- ssl_cert_issue_standalone() {
- #check for acme.sh first
- if ! command -v ~/.acme.sh/acme.sh &>/dev/null; then
- echo "acme.sh could not be found. we will install it"
- install_acme
- if [ $? -ne 0 ]; then
- LOGE "install acme failed, please check logs"
- exit 1
- fi
- fi
- #install socat second
- if [[ x"${release}" == x"centos" ]]; then
- yum install socat -y
- else
- apt install socat -y
- fi
- if [ $? -ne 0 ]; then
- LOGE "install socat failed,please check logs"
- exit 1
- else
- LOGI "install socat succeed..."
- fi
- #creat a directory for install cert
- certPath=/root/cert
- if [ ! -d "$certPath" ]; then
- mkdir $certPath
- else
- rm -rf $certPath
- mkdir $certPath
- fi
- #get the domain here,and we need verify it
- local domain=""
- read -p "please input your domain:" domain
- LOGD "your domain is:${domain},check it..."
- #here we need to judge whether there exists cert already
- local currentCert=$(~/.acme.sh/acme.sh --list | tail -1 | awk '{print $1}')
- if [ ${currentCert} == ${domain} ]; then
- local certInfo=$(~/.acme.sh/acme.sh --list)
- LOGE "system already have certs here,can not issue again,current certs details:"
- LOGI "$certInfo"
- exit 1
- else
- LOGI "your domain is ready for issuing cert now..."
- fi
- #get needed port here
- local WebPort=80
- read -p "please choose which port do you use,default will be 80 port:" WebPort
- if [[ ${WebPort} -gt 65535 || ${WebPort} -lt 1 ]]; then
- LOGE "your input ${WebPort} is invalid,will use default port"
- fi
- LOGI "will use port:${WebPort} to issue certs,please make sure this port is open..."
- #NOTE:This should be handled by user
- #open the port and kill the occupied progress
- ~/.acme.sh/acme.sh --set-default-ca --server letsencrypt
- ~/.acme.sh/acme.sh --issue -d ${domain} --standalone --httpport ${WebPort}
- if [ $? -ne 0 ]; then
- LOGE "issue certs failed,please check logs"
- rm -rf ~/.acme.sh/${domain}
- exit 1
- else
- LOGE "issue certs succeed,installing certs..."
- fi
- #install cert
- ~/.acme.sh/acme.sh --installcert -d ${domain} --ca-file /root/cert/ca.cer \
- --cert-file /root/cert/${domain}.cer --key-file /root/cert/${domain}.key \
- --fullchain-file /root/cert/fullchain.cer
- if [ $? -ne 0 ]; then
- LOGE "install certs failed,exit"
- rm -rf ~/.acme.sh/${domain}
- exit 1
- else
- LOGI "install certs succeed,enable auto renew..."
- fi
- ~/.acme.sh/acme.sh --upgrade --auto-upgrade
- if [ $? -ne 0 ]; then
- LOGE "auto renew failed,certs details:"
- ls -lah cert
- chmod 755 $certPath
- exit 1
- else
- LOGI "auto renew succeed,certs details:"
- ls -lah cert
- chmod 755 $certPath
- fi
- }
- #method for DNS API mode
- ssl_cert_issue_by_cloudflare() {
- echo -E ""
- LOGD "******Preconditions******"
- LOGI "1.need Cloudflare account associated email"
- LOGI "2.need Cloudflare Global API Key"
- LOGI "3.your domain use Cloudflare as resolver"
- confirm "I have confirmed all these info above[y/n]" "y"
- if [ $? -eq 0 ]; then
- install_acme
- if [ $? -ne 0 ]; then
- LOGE "install acme failed,please check logs"
- exit 1
- fi
- CF_Domain=""
- CF_GlobalKey=""
- CF_AccountEmail=""
- certPath=/root/cert
- if [ ! -d "$certPath" ]; then
- mkdir $certPath
- else
- rm -rf $certPath
- mkdir $certPath
- fi
- LOGD "please input your domain:"
- read -p "Input your domain here:" CF_Domain
- LOGD "your domain is:${CF_Domain},check it..."
- #here we need to judge whether there exists cert already
- local currentCert=$(~/.acme.sh/acme.sh --list | tail -1 | awk '{print $1}')
- if [ ${currentCert} == ${CF_Domain} ]; then
- local certInfo=$(~/.acme.sh/acme.sh --list)
- LOGE "system already have certs here,can not issue again,current certs details:"
- LOGI "$certInfo"
- exit 1
- else
- LOGI "your domain is ready for issuing cert now..."
- fi
- LOGD "please inout your cloudflare global API key:"
- read -p "Input your key here:" CF_GlobalKey
- LOGD "your cloudflare global API key is:${CF_GlobalKey}"
- LOGD "please input your cloudflare account email:"
- read -p "Input your email here:" CF_AccountEmail
- LOGD "your cloudflare account email:${CF_AccountEmail}"
- ~/.acme.sh/acme.sh --set-default-ca --server letsencrypt
- if [ $? -ne 0 ]; then
- LOGE "change the default CA to Lets'Encrypt failed,exit"
- exit 1
- fi
- export CF_Key="${CF_GlobalKey}"
- export CF_Email=${CF_AccountEmail}
- ~/.acme.sh/acme.sh --issue --dns dns_cf -d ${CF_Domain} -d *.${CF_Domain} --log
- if [ $? -ne 0 ]; then
- LOGE "issue cert failed,exit"
- rm -rf ~/.acme.sh/${CF_Domain}
- exit 1
- else
- LOGI "Certificate issued Successfully, Installing..."
- fi
- ~/.acme.sh/acme.sh --installcert -d ${CF_Domain} -d *.${CF_Domain} --ca-file /root/cert/ca.cer \
- --cert-file /root/cert/${CF_Domain}.cer --key-file /root/cert/${CF_Domain}.key \
- --fullchain-file /root/cert/fullchain.cer
- if [ $? -ne 0 ]; then
- LOGE "install cert failed,exit"
- rm -rf ~/.acme.sh/${CF_Domain}
- exit 1
- else
- LOGI "Certificate installed Successfully,Turning on automatic updates..."
- fi
- ~/.acme.sh/acme.sh --upgrade --auto-upgrade
- if [ $? -ne 0 ]; then
- LOGE "Auto update setup Failed, script exiting..."
- ls -lah cert
- chmod 755 $certPath
- exit 1
- else
- LOGI "The certificate is installed and auto-renewal is turned on, Specific information is as follows"
- ls -lah cert
- chmod 755 $certPath
- fi
- else
- show_menu
- fi
- }
- show_usage() {
- echo "x-ui control menu usages: "
- echo "------------------------------------------"
- echo -e "x-ui - Enter control menu"
- echo -e "x-ui start - Start x-ui "
- echo -e "x-ui stop - Stop x-ui "
- echo -e "x-ui restart - Restart x-ui "
- echo -e "x-ui status - Show x-ui status"
- echo -e "x-ui enable - Enable x-ui on system startup"
- echo -e "x-ui disable - Disable x-ui on system startup"
- echo -e "x-ui log - Check x-ui logs"
- echo -e "x-ui update - Update x-ui "
- echo -e "x-ui install - Install x-ui "
- echo -e "x-ui uninstall - Uninstall x-ui "
- echo "------------------------------------------"
- }
- show_menu() {
- echo -e "
- ${green}3X-ui Panel Management Script${plain}
- ${green}0.${plain} Exit Script
- ————————————————
- ${green}1.${plain} Install x-ui
- ${green}2.${plain} Update x-ui
- ${green}3.${plain} Uninstall x-ui
- ————————————————
- ${green}4.${plain} Reset Username And Password
- ${green}5.${plain} Reset Panel Settings
- ${green}6.${plain} Change Panel Port
- ${green}7.${plain} View Current Panel Settings
- ————————————————
- ${green}8.${plain} Start x-ui
- ${green}9.${plain} Stop x-ui
- ${green}10.${plain} Restart x-ui
- ${green}11.${plain} Check x-ui Status
- ${green}12.${plain} Check x-ui Logs
- ————————————————
- ${green}13.${plain} Enable x-ui On Sysyem Startup
- ${green}14.${plain} Disabel x-ui On Sysyem Startup
- ————————————————
- ${green}15.${plain} Enable BBR
- ${green}16.${plain} Issuse Certs
- "
- show_status
- echo && read -p "Please enter your selection [0-16]: " num
- case "${num}" in
- 0)
- exit 0
- ;;
- 1)
- check_uninstall && install
- ;;
- 2)
- check_install && update
- ;;
- 3)
- check_install && uninstall
- ;;
- 4)
- check_install && reset_user
- ;;
- 5)
- check_install && reset_config
- ;;
- 6)
- check_install && set_port
- ;;
- 7)
- check_install && check_config
- ;;
- 8)
- check_install && start
- ;;
- 9)
- check_install && stop
- ;;
- 10)
- check_install && restart
- ;;
- 11)
- check_install && status
- ;;
- 12)
- check_install && show_log
- ;;
- 13)
- check_install && enable
- ;;
- 14)
- check_install && disable
- ;;
- 15)
- install_bbr
- ;;
- 16)
- ssl_cert_issue
- ;;
- *)
- LOGE "Please enter the correct number [0-16]"
- ;;
- esac
- }
- if [[ $# > 0 ]]; then
- case $1 in
- "start")
- check_install 0 && start 0
- ;;
- "stop")
- check_install 0 && stop 0
- ;;
- "restart")
- check_install 0 && restart 0
- ;;
- "status")
- check_install 0 && status 0
- ;;
- "enable")
- check_install 0 && enable 0
- ;;
- "disable")
- check_install 0 && disable 0
- ;;
- "log")
- check_install 0 && show_log 0
- ;;
- "update")
- check_install 0 && update 0
- ;;
- "install")
- check_uninstall 0 && install 0
- ;;
- "uninstall")
- check_install 0 && uninstall 0
- ;;
- *) show_usage ;;
- esac
- else
- show_menu
- fi
|